﻿using System;
using System.Collections.Generic;
using System.Text;
using Mall.Model.Entity.Miai;
using Mall.Model.Extend.Miai;
using System.Linq;

namespace Mall.Repository.Miai
{
    /// <summary>
    /// 相亲消息仓储层
    /// </summary>
    public class RB_Miai_MessageRepository : BaseRepository<RB_Miai_Message>
    {

        /// <summary>
        /// 分页列表
        /// </summary>
        /// <param name="pageIndex">页码</param>
        /// <param name="pageSize">每页显示条数</param>
        /// <param name="rowCount">总条数</param>
        /// <param name="dmodel">查询条件</param>
        /// <returns></returns>
        public List<RB_Miai_Message_Extend> GetPageList(int pageIndex, int pageSize, out long rowCount, RB_Miai_Message_Extend dmodel)
        {
            string where = $" 1=1 ";
            if (dmodel.Status >= 0)
            {
                where += $@" and {nameof(RB_Miai_Message_Extend.Status)}={dmodel.Status}";
            }
            if (dmodel.TenantId > 0) {
                where += $@" and {nameof(RB_Miai_Message_Extend.TenantId)}={dmodel.TenantId}";
            }
            if (dmodel.MallBaseId > 0)
            {
                where += $@" and {nameof(RB_Miai_Message_Extend.MallBaseId)}={dmodel.MallBaseId}";
            }
            if (dmodel.UserId > 0)
            {
                where += $@" and {nameof(RB_Miai_Message_Extend.UserId)} ={dmodel.UserId}";
            }
            if (dmodel.Type > 0)
            {
                where += $@" and {nameof(RB_Miai_Message_Extend.Type)} ={(int)dmodel.Type}";
            }

            string sql = $@"select * from RB_Miai_Message where {where} order by Id desc";
            return GetPage<RB_Miai_Message_Extend>(pageIndex, pageSize, out rowCount, sql).ToList();
        }

        /// <summary>
        /// 获取列表
        /// </summary>
        /// <param name="dmodel"></param>
        /// <returns></returns>
        public List<RB_Miai_Message_Extend> GetList(RB_Miai_Message_Extend dmodel)
        {
            string where = $" 1=1 ";
            if (dmodel.Status >= 0)
            {
                where += $@" and {nameof(RB_Miai_Message_Extend.Status)}={dmodel.Status}";
            }
            if (dmodel.TenantId > 0)
            {
                where += $@" and {nameof(RB_Miai_Message_Extend.TenantId)}={dmodel.TenantId}";
            }
            if (dmodel.MallBaseId > 0)
            {
                where += $@" and {nameof(RB_Miai_Message_Extend.MallBaseId)}={dmodel.MallBaseId}";
            }
            if (dmodel.UserId > 0)
            {
                where += $@" and {nameof(RB_Miai_Message_Extend.UserId)} ={dmodel.UserId}";
            }
            if (dmodel.Type > 0)
            {
                where += $@" and {nameof(RB_Miai_Message_Extend.Type)} ={(int)dmodel.Type}";
            }

            string sql = $@"select * from RB_Miai_Message where {where} order by Id desc";
            return Get<RB_Miai_Message_Extend>(sql).ToList();
        }

        /// <summary>
        /// 批量清除
        /// </summary>
        /// <param name="type"></param>
        /// <param name="userId"></param>
        /// <returns></returns>
        public bool DelMiaiMessageInfoBatch(int type, int userId)
        {
            string sql = $@"update RB_Miai_Message set Status =1 where UserId ={userId}";
            if (type > 0) {
                sql += $@" and Type ={type}";
            }
            return Execute(sql) > 0;
        }

        /// <summary>
        /// 获取消息数量
        /// </summary>
        /// <param name="dmodel"></param>
        /// <returns></returns>
        public int GetMessageNum(RB_Miai_Message_Extend dmodel)
        {
            string where = $" 1=1 ";
            if (dmodel.Status >= 0)
            {
                where += $@" and {nameof(RB_Miai_Message_Extend.Status)}={dmodel.Status}";
            }
            if (dmodel.TenantId > 0)
            {
                where += $@" and {nameof(RB_Miai_Message_Extend.TenantId)}={dmodel.TenantId}";
            }
            if (dmodel.MallBaseId > 0)
            {
                where += $@" and {nameof(RB_Miai_Message_Extend.MallBaseId)}={dmodel.MallBaseId}";
            }
            if (dmodel.UserId > 0)
            {
                where += $@" and {nameof(RB_Miai_Message_Extend.UserId)} ={dmodel.UserId}";
            }
            if (dmodel.Type > 0)
            {
                where += $@" and {nameof(RB_Miai_Message_Extend.Type)} ={(int)dmodel.Type}";
            }

            string sql = $@"select count(0) from RB_Miai_Message where {where} ";
            var obj = ExecuteScalar(sql);
            return obj == null ? 0 : Convert.ToInt32(obj);
        }
    }
}
